uses crt,dos;
const
 xmin:longint =-40;
 xmax:longint = 41;
 ymin:longint =-25;
 ymax:longint = 26;
 sp10 = '          ';
 sp30=sp10+sp10+sp10;
 sp40=sp30+sp10;
 sp80=sp40+sp40;

type
  porg= ^org;
  org=record
   x,y     : longint;
   s       : byte;
   p       : porg
   end;
  sou=(wrk,inp);
  NmExt=string[12];
  oper=(ld,sv,kl);
var
  p0,p1                       : porg;
  next,newinit,exitp,go       : boolean;
  c,poc,n                     : longint;
  colname                     : NameStr;
{$B-}

function ReadKeyWord:word;
var regs:registers;
begin
  with regs do
  begin
    AH  :=  $10;
    intr($16,regs);
    ReadKeyWord:=AX
  end
end;

function KeyPressedEnh:boolean;
var regs:registers;
begin
  with regs do
  begin
    AH  :=  $11;
    intr($16,regs);
    KeyPressedEnh:=(flags and fzero)=0
  end
end;

procedure initorg(xx,yy:longint;var oldp:porg);
 var np:porg;
 begin new(np);oldp:=np;
   with np^ do begin
   y:=yy; x:=xx; s:=0; p:=nil
   end;
end;

procedure clrcol;
 var pg,pa:porg;
 begin
  pg:=p0;
  while pg<>nil do
  begin
    pa:=pg;pg:=pa^.p;Dispose(pa)
  end;
  p0:=nil;
  next:=false;
  newinit:=true;
  c:=0;
  poc:=0;n:=0;
  xmin:=-40;xmax:=41;
  ymin:=-25;ymax:=26;
  colname:=''
 end;


procedure out1;
var    xx,yy : longint;
begin
  xx:=wherex;yy:=wherey;
  gotoxy(1,1);write(sp40+sp10);
  gotoxy(2,1);write(colname);
  gotoxy(11,1);write('t',poc);
  gotoxy(21,1);write('*',c);
  gotoxy(31,1);write('X',xx+xmin);
  gotoxy(41,1);write('Y',yy+ymin);
  gotoxy(xx,yy)
end;

procedure coord(xx,yy   :longint);
 var pg         :porg;
     nn         :longint;
 begin
  if n<1 then n:=1;
  if p0=nil then n:=0;
  gotoxy(51,1);write(sp30);
  repeat
   pg:=p0;nn:=1;
   while (pg<>nil) and (nn<>n) do
   begin
     pg:=pg^.p;inc(nn)
   end;
   if pg<>nil then begin
                       TextColor(4);
                       gotoxy(51,1);write('*',n);
                       gotoxy(61,1);write('x',pg^.x);
                       gotoxy(71,1);write('y',pg^.y);
                       TextColor(0);
                       if go then begin
                                     xmin:=pg^.x-xx;xmax:=xmin+81;
                                     ymin:=pg^.y-yy;ymax:=ymin+51;
                                     go:=false
                                  end
                   end
              else n:=nn-1
 until (p0=nil)or(pg<>nil);
 end;

procedure output;
var pg    : porg;
    xx,yy : longint;
begin
  xx:=wherex;yy:=wherey;
  coord(xx,yy);
  window(1,2,80,50);
  clrscr;pg:=p0;c:=0;
  while pg<>nil do
  begin
    inc(c);
    if (pg^.x > xmin) and (pg^.x < xmax) and (pg^.y > ymin+1) and (pg^.y < ymax) then
      begin
       if c=n then TextColor(4);
       gotoxy (pg^.x-xmin,pg^.y-ymin-1);
       write ('*');
       if c=n then TextColor(0)
      end;
    pg:=pg^.p
  end;
  window(1,1,80,50);
  gotoxy(xx,yy);
  out1
end;

procedure setordel(xx,yy:longint);
var
   pg,oldp         : porg;
begin
  oldp:=nil;pg:=p0;
  while (pg<>nil) and ((xx<>pg^.x) or (yy<>pg^.y)) do
  begin
    oldp:=pg;pg:=pg^.p
  end;
  if pg=nil then
   begin
    initorg (xx,yy,p1);
    inc(n);
    if oldp<>nil then oldp^.p:=p1 else  p0:=p1;
   end
   else
   begin
    if oldp<>nil then oldp^.p:=pg^.p else p0:=pg^.p;
    dispose (pg);
    dec(n);
   end;
  if p0<>nil then colname:='WORK' else colname:=''
end;

procedure incs(xx,yy:longint);
 var pb,oldp:porg;
     cend:boolean;
 begin
   pb:=p0;cend:=false;oldp:=nil;
     while (pb<>nil) and (not cend) do
       if (xx= pb^.x) and (yy= pb^.y) then cend:=true else begin oldp:=pb; pb:=pb^.p end;
     if pb=nil then begin initorg(xx,yy,oldp^.p);pb:=oldp^.p end;
     inc(pb^.s)
   end;

procedure calc;
 var pa:porg;
 begin
   pa:=p0;
   while (pa<>nil) and (pa<>p1^.p) do begin
    with pa^ do
    begin
     incs(x+1,y);
     incs(x+1,y+1);
     incs(x,y+1);
     incs(x-1,y+1);
     incs(x-1,y);
     incs(x-1,y-1);
     incs(x,y-1);
     incs(x+1,y-1);
     pa:=p
    end
   end
end;

procedure Gener;
var
  pg,oldp,pa         : porg;
  gr,gran         : boolean;
begin
  oldp:=p0;pg:=p0;gran:=true;
  while pg<>nil do
  begin
    gr:=pg<>p1;
    if (pg^.s=3) or ((pg^.s=2 ) and gran) then
    begin
      oldp:=pg;pg^.s:=0;pg:=pg^.p
    end
    else
    begin
      pa:=pg;pg:=pa^.p;
      if pa=p0 then p0:=pg else oldp^.p:=pg;
      dispose (pa)
    end;
    gran:=gr and gran
  end;
  p1:=oldp;inc(poc)
end;

function FindFi(var n:word):NameStr;
var DirInfo : SearchRec;
    i       : word;
begin
  i:=1;
  FindFirst('*.lif',Archive,DirInfo);
  while (DosError=0) and (i<>n) do begin FindNext(DirInfo);inc(i) end;
  if DosError<>0 then
     if i<>1 then begin n:=i-1;FindFi:=FindFi(n) end
             else begin n:=1;  FindFi:=''        end
     else  FindFi:=Copy(DirInfo.Name,1,Length(DirInfo.Name)-4)
end;

function NameInput:NmExt;
type ByteRec=record
     lo,hi:byte
     end;
var name : NameStr;
    key,nfi : word;
    ex,fifi : boolean;
begin
  name:='';
  ex:=false;
  fifi:=false;
  nfi:=1;
  GotoXY(10,1);
  Write(sp40);
  GotoXY(10,1);
  Write('   䠩 ');
  repeat
    repeat until KeyPressedEnh;key:=ReadKeyWord;
    case key of
      $0e08  {bksp}  : delete(name,length(name),1);
      $1c0d  {enter} : ex:=true;
      $011b  {esc}   : begin name:='';ex:=true;fifi:=false end;
      $53e0  {del}   : name:='';
      $0f09  {tab}   : fifi:=not fifi;
      $48e0  {up}    : if fifi and (nfi<>1) then dec(nfi);
      $50e0  {down}  : if fifi then inc(nfi);
      $47e0  {home}  : if fifi then nfi:=1;
      $4fe0  {end}   : if fifi then nfi:=0;
    else
       if (length(name)<8) and (ByteRec(key).lo in [$30..$39,$61..$7a])
          then name:=name+Chr(ByteRec(key).lo);
    end;
    if fifi then name:=FindFi(nfi);
    GotoXY(30,1);
    Write(sp40);
    GotoXY(30,1);
    Write(name);
  until ex;
  if name<>'' then NameInput:=name+'.lif' else NameInput:=''
end;

procedure savefile(name:NmExt);
var pg:porg;
    f :file of longint;
    rwr:boolean;
begin
  assign(f,name);
  if name='work.lif' then rwr:=true else
  begin
    rwr:=false;
    {$I-}
    reset(f);
    {$I+}
    if IOResult<>0 then rwr:=true else
    begin
       GotoXY(10,1);
       Write(sp40);
       GotoXY(10,1);
       Write('  ',name,' 㦥 . p?');
       Close(f);
       repeat until KeyPressedEnh;if ReadKeyWord=$1579 then rwr:=true
    end
  end;
  if rwr then
  begin
       rewrite(f);
       pg:=p0;
       while pg<>nil do
         begin
          write(f,pg^.x,pg^.y);
          pg:=pg^.p
         end;
       close(f)
  end
end;

procedure loadfile(name:NmExt);
var pg,oldp:porg;
    xx,yy  :longint;
    f      :file of longint;
begin
  Assign(f,name);
  {$I-}
  Reset(f);
  {$I+}
  if IOResult<>0
  then
   begin
     GotoXY(10,1);
     Write(sp40);
     GotoXY(10,1);
     Write('  䠩 ',name);
     repeat until KeyPressedEnh;ReadKeyWord
   end
  else
   begin
     while not Eof(f) do
     begin
       Read(f,xx,yy);
       InitOrg(xx,yy,oldp);
       if p0=nil then p0:=oldp else pg^.p:=oldp;
       pg:=oldp
     end;
     p1:=pg;
     Close(f)
   end;
   colname:=Copy(name,1,length(name)-4)
end;

procedure killfile(name:NmExt);
var f : file of longint;
begin
  GotoXY(10,1);
  Write(sp40);
  GotoXY(10,1);
  Assign(f,name);
  {$I-}
  Reset(f);
  {$I+}
  if IOResult<>0
   then begin
         Write('  䠩 ',name);
         repeat until KeyPressedEnh;ReadKeyWord
        end
   else begin
         Close(f);
         Write('  ',name,'; 㢥p?');
         repeat until KeyPressedEnh;
         if ReadKeyWord=$1579 then Erase(f)
        end
end;

procedure operfile(op:oper;ns:sou);
var xx,yy:longint;
    name :NmExt;
begin
if ns=wrk then  case op of
                     ld:LoadFile('work.lif');
                     sv:SaveFile('work.lif');
                end
          else begin
                 xx:=wherex;yy:=wherey;
                 gotoxy(1,1);
                 write(sp80);
                 gotoxy(1,1);
                 case op of
                      ld: write('');
                      sv: write('');
                      kl: write('');
                 end;
                 name:=NameInput;
                 if name<>'' then case op of
                                       ld: LoadFile(name);
                                       sv: SaveFile(name);
                                       kl: KillFile(name);
                                  end;
                 gotoxy(xx,yy)
               end
end;

procedure init;
var
   pg    : porg;
   xx,yy : longint;
   ex    : boolean;
begin
  ex:=false;
  output;
  if not next then
  repeat
    xx:=wherex;
    yy:=wherey;
    repeat until KeyPressedEnh;
      case ReadKeyWord of
       $4be0  {left}    : if xx-1>=1 then gotoxy(xx-1,yy)
                          else begin dec(xmin);dec(xmax) end;
       $4de0  {right}   : if xx+1<=80 then gotoxy (xx+1,yy)
                          else begin inc(xmin);inc(xmax) end;
       $48e0  {up}      : if yy-1>=2 then gotoxy (xx,yy-1)
                          else begin dec(ymin);dec(ymax) end;
       $50e0  {down}    : if yy+1<=50 then gotoxy (xx,yy+1)
                          else begin inc(ymin);inc(ymax) end;
       $3920  {spase}   : if newinit then setordel(xmin+xx,ymin+yy);
       $1c0d  {enter}   : begin
                            if newinit and (p0<>nil) then OperFile(sv,wrk);
                            newinit:=false;calc;gener
                          end;
       $011b  {esc}     : begin ex:=true; exitp:= true end;
       $53e0  {del}     : begin ClrCol; ex:=true end;
       $4e2b  {gray+}   : begin
                            if newinit and (p0<>nil) then OperFile(sv,wrk);
                            newinit:=false;next:= true;ex:=true
                          end;
       $4b00  {gleft}   : begin dec(xmin);dec(xmax) end;
       $4d00  {gright}  : begin inc(xmin);inc(xmax) end;
       $4800  {gup}     : begin dec(ymin);dec(ymax) end;
       $5000  {gdown}   : begin inc(ymin);inc(ymax) end;
       $4900  {gpgup}   : inc(n);
       $5100  {gpgdn}   : dec(n);
       $4c00  {gcentr}  : go:=true;
       $52e0  {ins}     : if newinit then begin ClrCol;OperFile(ld,wrk) end;
       $3d00  {F3}      : begin ClrCol;OperFile(ld,inp) end;
       $3c00  {F2}      : OperFile(sv,inp);
       $4200  {F8}      : OperFile(kl,inp);
     end;
      output
    until ex
    else repeat
               calc;
               gener;
               output;
               if KeyPressedEnh  then
               case ReadKeyWord of
                  $4a2d {gray-},$1c0d {enter}: next:= false;
                  $53e0 {del} :begin next:=false;ClrCol end;
               end
         until not next
end;

BEGIN
  TextMode(Font8x8+co80);
  TextBackGround(7);
  TextColor (0);
  ClrScr;
  GotoXY(40,25);
 p0:=nil;p1:=nil;next:=false;exitp:=false;newinit:=true;n:=1;
 colname:='';
 repeat
      init;
 until exitp;
 ClrCol
end.